subroutine demographics

use params
implicit none

integer::t
double precision :: dummy

!variables to get stationary markov
double precision,dimension(ne,J,nh) :: put_h0
integer :: iter_markov
integer, parameter :: itmax_markov=5000
double precision, parameter :: tol_markov=1e-9
double precision ::d_markov
double precision :: pi_temp(nh,nh+1), pi_temptranspose(nh+1,nh)


integer, parameter :: ted=53, tsurv=136

    open (unit=1,file='input_health_probabilities.txt')
	do tc=1,J-1
        do ec=1,ne
        do hc=1,nh
        read(1,*)pi_h(ec,tc,:,hc),psi(ec,hc,tc)
!            read(1,*)pi_temp(hc,:)
!            psi(ec,hc,tc)=pi_temp(hc,nh+1)
!            psi(ec,hc,tc)=1-psi(ec,hc,tc)
        end do
!        pi_temptranspose=transpose(pi_temp)
!        pi_h(ec,tc,1:nh,1:nh)=pi_temptranspose(1:nh,1:nh)
        end do
	end do
    close(1)

psi(:,:,J)=0

    do ec=1,ne
    do tc=1,J-1
    do hc=1,nh
    dummy=sum(pi_h(ec,tc,:,hc))
    pi_h(ec,tc,:,hc)=pi_h(ec,tc,:,hc)/dummy
    end do
    end do
    end do
		
put_h0=one/nh

    do ec=1,ne
    do tc=2,J	

    iter_markov=0
    d_markov=1

        do while ( iter_markov .lt. itmax_markov .and. d_markov .gt. tol_markov )

        put_h(ec,tc,:)=matmul(put_h0(ec,tc,:),transpose(pi_h(ec,tc-1,:,:)))
        d_markov=maxval(abs(put_h0(ec,tc,:)-put_h(ec,tc,:)))
        put_h0(ec,tc,:)=put_h(ec,tc,:)
        iter_markov=iter_markov+1

        end do

        if ( iter_markov .ge. itmax_markov .and. rank .eq. 0 ) then
        print*,'iterations exceeed at markov at put_h',d_markov
            call exit
        end if
        
    end do
    end do

    put_h(:,:,1)=pc1
    put_h(:,:,2)=pc2-pc1
    put_h(:,:,3)=1-pc2
    
!first period health distribution (same as 21)
put_h(:,1,:)=put_h(:,2,:)

    if ( rank .eq. 0 ) then
    print*,'put_h(1) ',put_h(1,1,1)
    print*,'put_h(2) ',put_h(1,1,2)
    print*,'put_h(3) ',put_h(1,1,3)
!        call exit
    end if
    
!76 percent no college and 24 percent college (no high school, high school, and college)
put_e(1)=.7651926438
put_e(2)=1-put_e(1)

!deterministic age efficiency conditional on education 
    open(unit=1,file='input_age_efficiency.txt')
	do tc=1,J
	read(1,*)ep(1,tc),ep(2,tc)
	end do
    close(1)

!     do tc=jr,J
!     ep(:,tc)=0
!     end do

!variables for demographics (Note that t=1 and t=2 are 1960)
!     open (unit=1,file='input_education_attainment.txt')
!         do t=2,ted+1
!         read(1,*)put_e_t(1,t)
!         put_e_t(2,t)=1-put_e_t(1,t)
!         end do
!     close(1)
!
!     put_e_t(:,1)=put_e_t(:,2)
!
!     do t=ted+2,time
!     put_e_t(:,t)=put_e_t(:,ted+1)
!     end do
!
     do t=1,time
     put_e_t(:,t)=put_e
     end do
!
! psi_t=zero
!
! !variables for demographics (Note that t=1 and t=2 are 1960)
!
!     open (unit=1,file='input_survival_probabilities.txt')
!         do t=2,tsurv+1
!         read(1,*)psi_t(1,1,1:J-1,t)
!
!             do ec=1,ne
!             do hc=1,nh
!             psi_t(ec,hc,1:J-1,t)=psi_t(1,1,1:J-1,t)
!             end do
!             end do
!
!         end do
!     close(1)
!
!     psi_t(:,:,1:J-1,1)=psi_t(:,:,1:J-1,2)
!
!         do t=tsurv+2,time
!         psi_t(:,:,1:J-1,t)=psi_t(:,:,1:J-1,tsurv+1)
!         end do
!

     do t=1,time
     psi_t(:,:,:,t)=psi
     end do
   	
! Number of Agents in population by age and time

!N_{t+1}(ec,hc,tc)=sum (psi(ec,:,tc-1)*N_t(ec,:,tc-1)*pi_h(ec,tc-1,hc,:))
!Stationarity requires N_{t+1}(ec,hc,tc)=N_t (ec,hc,tc)
!So N_t(ec,hc,tc)=sum (psi(ec,:,tc-1)*N_t(ec,:,tc-1)*pi_h(ec,tc-1,hc,:))

!Now suppose N_{t+1}(ec,hc,tc)=N_t (ec,hc,tc) *(1+nn)
!Stationarity requires N_{t+1}(ec,hc,tc)/(1+nn)=N_t (ec,hc,tc)
!So N_t (ec,hc,tc)*(1+nn)=sum (psi(ec,:,tc-1)*N_t(ec,:,tc-1)*pi_h(ec,tc-1,hc,:))
! N_t (ec,hc,tc)=sum (psi(ec,:,tc-1)*N_t(ec,:,tc-1)*pi_h(ec,tc-1,hc,:))/(1+nn)

    do t=1,time
    do ec=1,ne
    do hc=1,nh
    Nu(ec,hc,1,t)=put_h(ec,1,hc)*put_e_t(ec,t)
    end do
    end do
    end do

!     do t=1,time
!     do tc=2,J
!     do ec=1,ne
!     do hc=1,nh
!     Nu(ec,hc,tc,t)=sum(psi(ec,:,tc-1)*Nu(ec,:,tc-1,t)*pi_h(ec,tc-1,hc,:))/(1+nn)	
!     end do
!     end do
!     end do
!     end do

    !stationary distribution of population in first period
    do tc=2,J
    do ec=1,ne
    do hc=1,nh
    Nu(ec,hc,tc,1)=sum(psi_t(ec,:,tc-1,1)*Nu(ec,:,tc-1,1)*pi_h(ec,tc-1,hc,:))/(1+nn)	
    end do
    end do
    end do

    do t=2,time
    do tc=2,J
    do ec=1,ne
    do hc=1,nh
    Nu(ec,hc,tc,t)=sum(psi_t(ec,:,tc-1,t-1)*Nu(ec,:,tc-1,t-1)*pi_h(ec,tc-1,hc,:))/(1+nn)	
    end do
    end do
    end do
    end do
    


    

    if ( rank .eq. 0 ) then
    
    print*,'dependency ratio ',sum(nu(:,:,jr:J,1))/sum(nu(:,:,1:jr-1,1))
    
        open (unit=1,file='check_pop.txt')
            do t=1,time
            write(1,*)sum(Nu(:,:,:,t))
            end do
        close(1)
        
    print*,'Nu 1,2, and 3 '
    write(6,'(300F12.5)')sum(Nu(:,1,:,1))/sum(Nu(:,:,:,1))
    write(6,'(300F12.5)')sum(Nu(:,2,:,1))/sum(Nu(:,:,:,1))
    write(6,'(300F12.5)')sum(Nu(:,3,:,1))/sum(Nu(:,:,:,1))    

        open (unit=1,file='check_ergodic.txt')
            do tc=1,J
            write(1,'(I2,300F12.5)')tc+19,sum(Nu(:,1,tc,1))/sum(Nu(:,:,tc,1)),sum(Nu(:,2,tc,1))/sum(Nu(:,:,tc,1)),sum(Nu(:,3,tc,1))/sum(Nu(:,:,tc,1)),sum(Nu(:,:,tc,1))
            end do
        close(1)
    
!        call exit


        
        
    end if

end subroutine demographics

