subroutine insexpdist (iexp, expage, expedu, expasset, exphealth, expprod)
use params
implicit none

!insurance distribution by expense (private, self, employer, Medicare, Welfare, Medicaid)
double precision :: iexp(6), expage(J,6), expedu(ne,6), expasset(na,6), exphealth(nh,6), expprod(ns,6)
double precision,allocatable, dimension(:,:,:,:,:,:) :: privateexpfunss, selfexpfunss, employerexpfunss
double precision,allocatable, dimension(:,:,:,:,:,:) :: medicareexpfunss, welfareexpfunss
double precision :: expense(6)

allocate (privateexpfunss(ng,ne,nh,ns,na,J), selfexpfunss(ng,ne,nh,ns,na,J), employerexpfunss(ng,ne,nh,ns,na,J))
allocate (medicareexpfunss(ng,ne,nh,ns,na,J), welfareexpfunss(ng,ne,nh,ns,na,J))

privateexpfunss=0
selfexpfunss=0
employerexpfunss=0
medicareexpfunss=0
welfareexpfunss=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    do ac=1,na

        if ( tc .lt. jr ) then

            if ( gc .eq. 1 ) then

            privateexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*cov_p(hc)

                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                selfexpfunss(gc,ec,hc,sc,ac,tc)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)*(1-cov_mdss(tc))/cov_mdss(tc)
                else if ( g_dfss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then
                welfareexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_p(hc))
                else
                selfexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_p(hc))
                end if

            else if ( gc .eq. 2 ) then

                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                selfexpfunss(gc,ec,hc,sc,ac,tc)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)*(1-cov_mdss(tc))/cov_mdss(tc)
                else if ( g_dfss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then
                welfareexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)
                else
                selfexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)
                end if

            else if ( gc .eq. 3 ) then

                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                employerexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*cov_e(hc)
                selfexpfunss(gc,ec,hc,sc,ac,tc)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)*(1-cov_mdss(tc))/cov_mdss(tc)
                else if ( g_dfss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then
                welfareexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)
                else
                employerexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*cov_e(hc)
                selfexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_e(hc))
                end if

            end if

        else if ( tc .ge. jr ) then

        medicareexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*cov_mss
	
            if ( gc .eq. 1 ) then

            privateexpfunss(gc,ec,hc,sc,ac,tc)=(1-cov_mss)*e_h(hc,tc)*cov_p(hc)

                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                selfexpfunss(gc,ec,hc,sc,ac,tc)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)*(1-cov_mdss(tc))/cov_mdss(tc)
                else if ( g_dfss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then
                welfareexpfunss(gc,ec,hc,sc,ac,tc)=(1-cov_mss)*e_h(hc,tc)*(1-cov_p(hc))
                else
                selfexpfunss(gc,ec,hc,sc,ac,tc)=(1-cov_mss)*e_h(hc,tc)*(1-cov_p(hc))
                end if

            else if ( gc .eq. 2 ) then

                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                selfexpfunss(gc,ec,hc,sc,ac,tc)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)*(1-cov_mdss(tc))/cov_mdss(tc)
                else if ( g_dfss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then
                welfareexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_mss)
                else
                selfexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_mss)
                end if

            else if ( gc .eq. 3 ) then

                if ( g_dmss(gc,ec,hc,sc,ac,tc) .eq. 1 ) then
                selfexpfunss(gc,ec,hc,sc,ac,tc)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)*(1-cov_mdss(tc))/cov_mdss(tc)
                else if ( g_dfss(gc,ec,hc,sc,ac,tc) .eq. 0 ) then
                welfareexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_mss)
                else
                selfexpfunss(gc,ec,hc,sc,ac,tc)=e_h(hc,tc)*(1-cov_mss)
                end if
            end if
        end if

    expense(1)=privateexpfunss(gc,ec,hc,sc,ac,tc)
    expense(2)=selfexpfunss(gc,ec,hc,sc,ac,tc)
    expense(3)=employerexpfunss(gc,ec,hc,sc,ac,tc)
    expense(4)=medicareexpfunss(gc,ec,hc,sc,ac,tc)
    expense(5)=welfareexpfunss(gc,ec,hc,sc,ac,tc)
    expense(6)=medicaidexpfunss(gc,ec,hc,sc,ac,tc)

    hifunss(gc,ec,hc,sc,ac,tc)=maxloc(expense,1)

    end do
    end do
    end do
    end do
    end do
    end do

iexp=0
expage=0
expedu=0
expasset=0
exphealth=0
expprod=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    do ac=1,na

    iexp(1)=iexp(1)+privateexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    iexp(2)=iexp(2)+selfexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    iexp(3)=iexp(3)+employerexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    iexp(4)=iexp(4)+medicareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    iexp(5)=iexp(5)+welfareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    iexp(6)=iexp(6)+medicaidexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)

    expage(tc,1)=expage(tc,1)+privateexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expage(tc,2)=expage(tc,2)+selfexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expage(tc,3)=expage(tc,3)+employerexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expage(tc,4)=expage(tc,4)+medicareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expage(tc,5)=expage(tc,5)+welfareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expage(tc,6)=expage(tc,6)+medicaidexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)

    expedu(ec,1)=expedu(ec,1)+privateexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expedu(ec,2)=expedu(ec,2)+selfexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expedu(ec,3)=expedu(ec,3)+employerexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expedu(ec,4)=expedu(ec,4)+medicareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expedu(ec,5)=expedu(ec,5)+welfareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expedu(ec,6)=expedu(ec,6)+medicaidexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)

    expasset(ac,1)=expasset(ac,1)+privateexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expasset(ac,2)=expasset(ac,2)+selfexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expasset(ac,3)=expasset(ac,3)+employerexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expasset(ac,4)=expasset(ac,4)+medicareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expasset(ac,5)=expasset(ac,5)+welfareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expasset(ac,6)=expasset(ac,6)+medicaidexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)

    exphealth(hc,1)=exphealth(hc,1)+privateexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    exphealth(hc,2)=exphealth(hc,2)+selfexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    exphealth(hc,3)=exphealth(hc,3)+employerexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    exphealth(hc,4)=exphealth(hc,4)+medicareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    exphealth(hc,5)=exphealth(hc,5)+welfareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    exphealth(hc,6)=exphealth(hc,6)+medicaidexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)

    expprod(sc,1)=expprod(sc,1)+privateexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expprod(sc,2)=expprod(sc,2)+selfexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expprod(sc,3)=expprod(sc,3)+employerexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expprod(sc,4)=expprod(sc,4)+medicareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expprod(sc,5)=expprod(sc,5)+welfareexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)
    expprod(sc,6)=expprod(sc,6)+medicaidexpfunss(gc,ec,hc,sc,ac,tc)*phissadjusted(gc,ec,hc,sc,ac,tc)*nuss(ec,hc,tc)

    end do
    end do
    end do
    end do
    end do
    end do

deallocate (privateexpfunss, selfexpfunss, employerexpfunss, medicareexpfunss, welfareexpfunss)

end subroutine insexpdist